import { TransformPoint } from "../geometry/types";
import { IProjectionNode } from "./types";
export declare function measureViewportBox(instance: HTMLElement, transformPoint?: TransformPoint): import("../geometry/types").Box;
export declare const HTMLProjectionNode: {
    new (parent?: IProjectionNode<unknown> | undefined): {
        instance: HTMLElement;
        root: IProjectionNode<unknown>;
        parent: IProjectionNode<unknown>;
        path: IProjectionNode<unknown>[];
        children: Set<IProjectionNode<unknown>>;
        options: import("./types").ProjectionNodeOptions;
        snapshot: import("./types").Snapshot | undefined;
        layout: import("../geometry/types").Box | undefined;
        layoutCorrected: import("../geometry/types").Box;
        scroll?: import("../geometry/types").Point | undefined;
        isLayoutDirty: boolean;
        shouldResetTransform: boolean;
        treeScale: import("../geometry/types").Point;
        targetDelta?: import("../geometry/types").Delta | undefined;
        projectionDelta?: import("../geometry/types").Delta | undefined;
        target?: import("../geometry/types").Box | undefined;
        layoutWillUpdateListeners?: import("../../utils/subscription-manager").SubscriptionManager<VoidFunction> | undefined;
        layoutDidUpdateListeners?: import("../../utils/subscription-manager").SubscriptionManager<import("./types").LayoutUpdateHandler> | undefined;
        destructor(): void;
        mount(instance: HTMLElement): void;
        willUpdate(shouldNotifyListeners?: boolean): void;
        didUpdate(): void;
        scheduleUpdateProjection(): void;
        updateProjection: () => void;
        updateSnapshot(): void;
        updateLayout(): void;
        updateScroll(): void;
        resetTransform(): void;
        measure(): import("../geometry/types").Box;
        removeElementScroll(box: import("../geometry/types").Box): import("../geometry/types").Box;
        setTargetDelta(delta: import("../geometry/types").Delta): void;
        setOptions(options: import("./types").ProjectionNodeOptions): void;
        resolveTargetDelta(): void;
        calcProjection(): void;
        getProjectionStyles(latest: import("../../render/types").ResolvedValues): import("../../render/types").ResolvedValues;
        onLayoutWillUpdate(handler: VoidFunction): () => void;
        onLayoutDidUpdate(handler: (data: import("./types").LayoutUpdateData) => void): () => void;
    };
};
